require "mscorlib"
require "System.Windows.Forms"
require "System.Drawing"


class FormToolSizeDialog < System::Windows::Forms::Form

  def initialize()
    @tool_size = {}
    @cutter_size = 0.5
    @cutter_textbox = nil
    @done = true
  end

  attr_accessor :tool_size
  attr_accessor :cutter_size
  attr_reader :done

  def InitializeComponent()
    @button1 = System::Windows::Forms::Button.new()
    @button2 = System::Windows::Forms::Button.new()
    @labels = []
    @textboxs = []
    self.SuspendLayout()
    #
    # ----- cutter edit
    #
    pos_y = 15
    index = 2
    label = System::Windows::Forms::Label.new()
    label.Location = System::Drawing::Point.new(15, pos_y)
    label.Name = "labelCutter"
    label.Size = System::Drawing::Size.new(80, 16)
    label.TabIndex = 11
    label.Text = "Cutter Size"
    @cutter_label = label
    #
    textbox = System::Windows::Forms::TextBox.new()
    textbox.Location = System::Drawing::Point.new(100, pos_y-2)
    textbox.Name = "CutterSize"
    textbox.Size = System::Drawing::Size.new(40, 19)
    textbox.TabIndex = index
    textbox.Text = @cutter_size.to_s
    textbox.TextAlign = System::Windows::Forms::HorizontalAlignment.Right
    @cutter_textbox = textbox
    pos_y += 24
    index += 1
    #
    # ----- tool edit
    #
    @tool_size.each do |item_key, item_value|
      label = System::Windows::Forms::Label.new()
      label.Location = System::Drawing::Point.new(15, pos_y)
      label.Name = "label"+item_key
      label.Size = System::Drawing::Size.new(60, 16)
      label.TabIndex = 10
      label.Text = "T"+item_key
      @labels << label
      #
      textbox = System::Windows::Forms::TextBox.new()
      textbox.Location = System::Drawing::Point.new(100, pos_y-2)
      textbox.Name = item_key
      textbox.Size = System::Drawing::Size.new(40, 19)
      textbox.TabIndex = index
      textbox.Text = item_value.to_s
      textbox.TextAlign = System::Windows::Forms::HorizontalAlignment.Right
      @textboxs << textbox
      #
      pos_y += 24
      index += 1
    end

    # 
    # button1
    # 
    @button1.DialogResult = System::Windows::Forms::DialogResult.Cancel
    @button1.Location = System::Drawing::Point.new(115, 322)
    @button1.Name = "button1"
    @button1.Size = System::Drawing::Size.new(75, 23)
    @button1.TabIndex = 0
    @button1.Text = "Cancal"
    @button1.UseVisualStyleBackColor = true
    # 
    # button2
    # 
    @button2.DialogResult = System::Windows::Forms::DialogResult.OK
    @button2.Location = System::Drawing::Point.new(30, 322)
    @button2.Name = "button2"
    @button2.Size = System::Drawing::Size.new(75, 23)
    @button2.TabIndex = 1
    @button2.Text = "OK"
    @button2.UseVisualStyleBackColor = true
    # 
    # Form1
    # 
    self.Controls.Add(@cutter_label)
    self.Controls.Add(@cutter_textbox)
    self.ClientSize = System::Drawing::Size.new(200, 360)
    @labels.each do |item|
      self.Controls.Add(item)
    end
    @textboxs.each do |item|
      self.Controls.Add(item)
    end
    self.Controls.Add(@button2)
    self.Controls.Add(@button1)
    self.MaximizeBox = false
    self.MinimizeBox = false
    self.Name = "DrillSizeDialog"
    self.ShowIcon = false
    self.ShowInTaskbar = false
    self.FormBorderStyle = System::Windows::Forms::FormBorderStyle.FixedDialog
    self.StartPosition = System::Windows::Forms::FormStartPosition.CenterParent
    self.Text = "Tool Size Preference"
    self.FormClosed{ on_close }
    self.ResumeLayout(false)
    self.PerformLayout()
  end

  def set_tool(tool)
    @tool_size = tool
    InitializeComponent()
  end

  def ShowDialog
    super
  end

  def on_close
    begin
      Float(@cutter_textbox.Text)
      @cutter_size = @cutter_textbox.Text.to_f
      @textboxs.each do |item|
        Float(item.Text)
        @tool_size[item.name] = item.Text.to_f
      end
      @done = true
    rescue Exception => e
      @done = false
      System::Windows::Forms::MessageBox.Show("Parameter Error!\nprease retry")
    end
  end

end
